package com.mxgraph.swing.examples.editor;

import javax.swing.JMenu;
import javax.swing.JPopupMenu;
import javax.swing.TransferHandler;

import com.mxgraph.swing.examples.BasicGraphEditor;
import com.mxgraph.swing.examples.editor.EditorActions.UndoAction;
import com.mxgraph.swing.util.mxGraphActions;
import com.mxgraph.util.mxResources;

public class EditorPopupMenu extends JPopupMenu
{

	public EditorPopupMenu(BasicGraphEditor frame)
	{
		boolean selected = !frame.getGraphComponent().getGraph()
				.isSelectionEmpty();

		add(frame.bind(mxResources.get("undo"), new UndoAction(frame),
				"/com/mxgraph/swing/examples/images/undo.gif"));

		addSeparator();

		add(
				frame.bind(mxResources.get("cut"), TransferHandler
						.getCutAction(),
						"/com/mxgraph/swing/examples/images/cut.gif"))
				.setEnabled(selected);
		add(
				frame.bind(mxResources.get("copy"), TransferHandler
						.getCopyAction(),
						"/com/mxgraph/swing/examples/images/copy.gif"))
				.setEnabled(selected);
		add(frame.bind(mxResources.get("paste"), TransferHandler
				.getPasteAction(),
				"/com/mxgraph/swing/examples/images/paste.gif"));

		addSeparator();

		add(
				frame.bind(mxResources.get("delete"), mxGraphActions
						.getDeleteAction(),
						"/com/mxgraph/swing/examples/images/delete.gif"))
				.setEnabled(selected);

		addSeparator();

		// Creates the format menu
		JMenu menu = (JMenu) add(new JMenu(mxResources.get("format")));

		EditorMenuBar.populateFormatMenu(menu, frame);

		// Creates the shape menu
		menu = (JMenu) add(new JMenu(mxResources.get("shape")));

		EditorMenuBar.populateShapeMenu(menu, frame);

		addSeparator();

		add(frame.bind(mxResources.get("edit"), mxGraphActions.getEditAction()))
				.setEnabled(selected);

		addSeparator();

		add(frame.bind(mxResources.get("selectVertices"), mxGraphActions
				.getSelectVerticesAction()));
		add(frame.bind(mxResources.get("selectEdges"), mxGraphActions
				.getSelectEdgesAction()));

		addSeparator();

		add(frame.bind(mxResources.get("selectAll"), mxGraphActions
				.getSelectAllAction()));
	}

}
